<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-cmd-client", {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.node-conf')
      },
      service: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.service')
      },
      stdInputs: [
        {
          property: "timeout",
          label: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.timeout'),
          icon: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.timeout-icon'),
          placeholder: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.default.timeout'),
          unit: RED._('node-red-dim-xml/dicXmlCmd:dicXmlCmd.label.timeout-unit'),
          width: "100px"
        }
      ]
    });

    RED.nodes.registerType("dim-xml-cmd-client", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(dicXml.regExp.srvName)
        },
        timeout: { value: 1000 }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 1,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML CMD Client");
      },
      oneditprepare: function() {
        $("#node-input-timeout").typedInput({
          type: "num",
          types: ["num"]
        });

        const ddl = dimXml.utils.initDropDownList();
        if (ddl) {
          const updateDdl = async () => {
            const srvList = await dimXml.utils.serviceList();

            /* service list filtering */
            let filteredList = [];
            if (Array.isArray(srvList)) {
              srvList.forEach(s => {
                if (s.type === 'CMD' && s.definition === 'C' &&
                  s.name.endsWith('/Cmd')) {
                  filteredList.push(s.name.split('/Cmd')[0]);
                }
              });
            }

            ddl.append(filteredList);
          }
          updateDdl();

          $('#node-input-cnf').one('focus', function() {
            $(this).change(function() {
              ddl.clear();
              updateDdl();
            });
          });
        }
      }
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-cmd-client"></script>
